/**
 * @version 1.0.0.0
 * @copyright Copyright ©  2017
 * @compiler Bridge.NET 15.7.0
 */
Bridge.assembly("AlienAttack", function ($asm, globals) {
    "use strict";

    Bridge.define("AlienAttack.App", {
        statics: {
            zombies: null,
            imp: null,
            zombieTypes: null,
            plantTypes: null,
            backupDancer: null,
            crater: null,
            frames: 0,
            fps: 20,
            b: 1200,
            nonD: 1200,
            plantTable: null,
            images: null,
            task: null,
            rechargeTimes: null,
            spans: null,
            plants: null,
            sun$1: 50,
            selected: null,
            squareWidth: 100,
            squareHeight: 100,
            gridWidth: 9,
            gridHeight: 5,
            speedConstant: 250,
            frameMilestones: null,
            rnd: null,
            shots: null,
            intervals: null,
            loaded: null,
            sun: null,
            levelType: 0,
            animColors: null,
            colors: null,
            config: {
                init: function () {
                    this.zombies = new (System.Collections.Generic.List$1(AlienAttack.Zombie))();
                    this.imp = Bridge.merge(new AlienAttack.ZombieType(), {
        speed: 2,
        startingHealth: 10,
        magnetVulnerable: false,
        name: "Imp"
    } );
                    this.zombieTypes = $asm.$.AlienAttack.App.f1(new (System.Collections.Generic.List$1(AlienAttack.ZombieType))());
                    this.plantTypes = $asm.$.AlienAttack.App.f29(new (System.Collections.Generic.List$1(AlienAttack.PlantType))());
                    this.backupDancer = Bridge.merge(new AlienAttack.ZombieType(), {
        name: "Backup Dancer",
        startingHealth: 10
    } );
                    this.crater = System.Linq.Enumerable.from(AlienAttack.App.plantTypes).last();
                    this.plantTable = new (System.Collections.Generic.Dictionary$2(AlienAttack.PlantType,HTMLSpanElement))();
                    this.images = new (System.Collections.Generic.Dictionary$2(String,HTMLImageElement))();
                    this.rechargeTimes = $asm.$.AlienAttack.App.f30(new (System.Collections.Generic.Dictionary$2(AlienAttack.RechargeTime,System.Int32))());
                    this.spans = new (System.Collections.Generic.Dictionary$2(AlienAttack.PlantType,HTMLSpanElement))();
                    this.plants = new (System.Collections.Generic.List$1(AlienAttack.Plant))();
                    this.frameMilestones = new (System.Collections.Generic.List$1(System.Int32))();
                    this.rnd = new System.Random.ctor();
                    this.shots = new (System.Collections.Generic.List$1(AlienAttack.Shot))();
                    this.intervals = new (System.Collections.Generic.Dictionary$2(AlienAttack.Plant,System.Collections.Generic.List$1(System.Int32)))();
                    this.loaded = new (System.Collections.Generic.Dictionary$2(String,HTMLImageElement))();
                    this.sun = new (System.Collections.Generic.List$1(AlienAttack.Sun))();
                    this.animColors = System.Array.init(["#005000", "#ffff00", "#ff0000"], String);
                    this.colors = $asm.$.AlienAttack.App.f31(new (System.Collections.Generic.Dictionary$2(AlienAttack.ShotData.ShotType,String))());
                }
            },
            getCanvas: function () {
                return document.getElementById("canvas");
            },
            getTable: function () {
                return document.getElementById("table");
            },
            startZombiePlan: function () {
                var $t;
                for (var n = 0; n < 50; n = (n + 1) | 0) {
                    AlienAttack.App.frameMilestones.add(Bridge.Int.clip32(AlienAttack.App.b));
                    AlienAttack.App.b += ($t = AlienAttack.App.nonD * 0.99, AlienAttack.App.nonD = $t, $t);
                }
            },
            loadImages: function () {
                var $step = 0,
                    $task1, 
                    $taskResult1, 
                    $task2, 
                    $taskResult2, 
                    $jumpFromFinally, 
                    $tcs = new System.Threading.Tasks.TaskCompletionSource(), 
                    $returnValue, 
                    $t, 
                    plant, 
                    n, 
                    string, 
                    idx, 
                    toWrite, 
                    $async_e, 
                    $asyncBody = Bridge.fn.bind(this, function () {
                        try {
                            for (;;) {
                                $step = System.Array.min([0,1,2,3,4,5,6,7,8,9,10,11,12,13,15,17,18], $step);
                                switch ($step) {
                                    case 0: {
                                        $t = Bridge.getEnumerator(AlienAttack.App.plantTypes);
                                            $step = 1;
                                            continue;
                                    }
                                    case 1: {
                                        if ($t.moveNext()) {
                                                plant = $t.getCurrent();
                                                $step = 2;
                                                continue;
                                            }
                                        $step = 18;
                                        continue;
                                    }
                                    case 2: {
                                        if (plant.image) {
                                                $step = 3;
                                                continue;
                                            } 
                                            $step = 17;
                                            continue;
                                    }
                                    case 3: {
                                        n = 0;
                                            $step = 4;
                                            continue;
                                    }
                                    case 4: {
                                        if ( n < plant.nFrames ) {
                                                $step = 5;
                                                continue;
                                            }
                                        $step = 16;
                                        continue;
                                    }
                                    case 5: {
                                        string = System.String.format("{0} {1}", plant.name, ((n + 1) | 0));
                                            if (plant.anim != null) {
                                                $step = 6;
                                                continue;
                                            } else  {
                                                $step = 12;
                                                continue;
                                            }
                                    }
                                    case 6: {
                                        idx = 0;
                                            $step = 7;
                                            continue;
                                    }
                                    case 7: {
                                        if ( idx < ((plant.anim.length + 1) | 0) ) {
                                                $step = 8;
                                                continue;
                                            }
                                        $step = 11;
                                        continue;
                                    }
                                    case 8: {
                                        toWrite = System.String.format("{0} {1}", string, idx);
                                            $task1 = AlienAttack.App.loadImage(toWrite);
                                            $step = 9;
                                            $task1.continueWith($asyncBody);
                                            return;
                                    }
                                    case 9: {
                                        $taskResult1 = $task1.getAwaitedResult();
                                        AlienAttack.App.images.add(toWrite, $taskResult1);
                                        $step = 10;
                                        continue;
                                    }
                                    case 10: {
                                        idx = (idx + 1) | 0;
                                        $step = 7;
                                        continue;
                                    }
                                    case 11: {
                                        $step = 14;
                                        continue;
                                    }
                                    case 12: {
                                        $task2 = AlienAttack.App.loadImage(string);
                                            $step = 13;
                                            $task2.continueWith($asyncBody);
                                            return;
                                    }
                                    case 13: {
                                        $taskResult2 = $task2.getAwaitedResult();
                                        AlienAttack.App.images.add(string, $taskResult2);
                                        $step = 14;
                                        continue;
                                    }

                                    case 15: {
                                        n = (n + 1) | 0;
                                        $step = 4;
                                        continue;
                                    }

                                    case 17: {
                                        $step = 1;
                                        continue;
                                    }
                                    case 18: {
                                        $tcs.setResult(null);
                                        return;
                                    }
                                    default: {
                                        $tcs.setResult(null);
                                        return;
                                    }
                                }
                            }
                        } catch($async_e1) {
                            $async_e = System.Exception.create($async_e1);
                            $tcs.setException($async_e);
                        }
                    }, arguments);

                $asyncBody();
                return $tcs.task;
            },
            loadImage: function (v) {
                var $step = 0,
                    $task1, 
                    $taskResult1, 
                    $jumpFromFinally, 
                    $tcs = new System.Threading.Tasks.TaskCompletionSource(), 
                    $returnValue, 
                    image, 
                    $async_e, 
                    $asyncBody = Bridge.fn.bind(this, function () {
                        try {
                            for (;;) {
                                $step = System.Array.min([0,1], $step);
                                switch ($step) {
                                    case 0: {
                                        image = Bridge.merge(new Image(), {
                                                src: System.String.format("images/{0}.png", v)
                                            } );
                                            image.onload = function (e) {
                                                AlienAttack.App.task.setResult(image);
                                            };
                                            AlienAttack.App.task = new System.Threading.Tasks.TaskCompletionSource();
                                            $task1 = AlienAttack.App.task.task;
                                            $step = 1;
                                            $task1.continueWith($asyncBody);
                                            return;
                                    }
                                    case 1: {
                                        $taskResult1 = $task1.getAwaitedResult();
                                        $tcs.setResult($taskResult1);
                                            return;
                                    }
                                    default: {
                                        $tcs.setResult(null);
                                        return;
                                    }
                                }
                            }
                        } catch($async_e1) {
                            $async_e = System.Exception.create($async_e1);
                            $tcs.setException($async_e);
                        }
                    }, arguments);

                $asyncBody();
                return $tcs.task;
            },
            selectWorkaround: function (mouseEvent) {
                AlienAttack.App.select(System.Linq.Enumerable.from(AlienAttack.App.plantTypes).first(function (v) {
                        return Bridge.referenceEquals(v.name, mouseEvent.target.textContent);
                    }));
            },
            mouseDown: function (arg) {
                var $t;
                var x = (((Bridge.Int.div(arg.layerX, AlienAttack.App.squareWidth)) | 0));
                var y = (((Bridge.Int.div(arg.layerY, AlienAttack.App.squareHeight)) | 0));
                $t = Bridge.getEnumerator(AlienAttack.App.sun);
                while ($t.moveNext()) {
                    var _sun = $t.getCurrent();
                    if (Bridge.Math.round(_sun.x, 0, 6) === x && _sun.y === y) {
                        AlienAttack.App.sun.remove(_sun);
                        AlienAttack.App.sun$1 = (AlienAttack.App.sun$1 + _sun.amount) | 0;
                        return;
                    }
                }
                if (System.Linq.Enumerable.from(AlienAttack.App.plants).any(function (v) {
                        return v.x === x && v.y === y;
                    }) && !AlienAttack.App.selected.overPlantable) {
                    return;
                }
                if (AlienAttack.App.selected.sinceLastPlanting < AlienAttack.App.rechargeTimes.get(AlienAttack.App.selected.rechargeTime)) {
                    return;
                }
                if (AlienAttack.App.sun$1 < AlienAttack.App.selected.cost) {
                    return;
                }
                AlienAttack.App.plantTable.get(AlienAttack.App.selected).style.color = "#ff8080";
                AlienAttack.App.selected.sinceLastPlanting = 0;
                var plant = AlienAttack.Plant.createPlant(AlienAttack.App.selected, x, y);
                AlienAttack.App.plants.add(plant);
                if (AlienAttack.App.selected.nocturnal && AlienAttack.App.levelType === AlienAttack.LevelType.Day) {
                    plant.asleep = true;
                }
                AlienAttack.App.updateShotsAnim(plant);
                AlienAttack.App.sun$1 = (AlienAttack.App.sun$1 - AlienAttack.App.selected.cost) | 0;
            },
            select: function (plantType) {
                AlienAttack.App.plantTable.get(AlienAttack.App.selected).style.color = AlienAttack.App.selected.sinceLastPlanting >= AlienAttack.App.rechargeTimes.get(AlienAttack.App.selected.rechargeTime) ? "black" : "#ffff80";
                AlienAttack.App.plantTable.get((AlienAttack.App.selected = plantType, plantType)).style.color = plantType.sinceLastPlanting >= AlienAttack.App.rechargeTimes.get(plantType.rechargeTime) ? "orange" : "#ff8080";
            },
            removePlantUpdateAnim: function (remove) {
                var $t;
                if (AlienAttack.App.intervals.containsKey(remove)) {
                    $t = Bridge.getEnumerator(AlienAttack.App.intervals.get(remove));
                    while ($t.moveNext()) {
                        var item = $t.getCurrent();
                        Bridge.global.clearInterval(item);
                    }
                    AlienAttack.App.intervals.remove(remove);
                }
            },
            updateShotsAnim: function (plant) {
                var $t;
                if (plant.asleep) {
                    return;
                }
                $t = Bridge.getEnumerator(plant.type.actions);
                while ($t.moveNext()) {
                    (function () {
                        var action = $t.getCurrent();
                        if (!AlienAttack.App.intervals.containsKey(plant)) {
                            AlienAttack.App.intervals.add(plant, new (System.Collections.Generic.List$1(System.Int32))());
                        }
                        if (Bridge.is(action, AlienAttack.ShooterAction)) {
                            var shooterAction_ = Bridge.cast(action, AlienAttack.ShooterAction);

                            AlienAttack.App.intervals.get(plant).add(Bridge.global.setInterval(function () {
                                var $t1, $t2;
                                var shoot = false;
                                $t1 = Bridge.getEnumerator(shooterAction_.shotData);
                                while ($t1.moveNext()) {
                                    (function () {
                                        var shooterAction = $t1.getCurrent();
                                        if (System.Linq.Enumerable.from(AlienAttack.App.zombies).any(function (v) {
                                                return v.y === (((plant.y + (shooterAction.lineDif)) | 0)) && Math.abs(Math.floor(v.x - plant.x)) < shooterAction.range && (plant.x <= v.x || shooterAction.backwards);
                                            })) {
                                            shoot = true;
                                        }
                                    }).call(this);
                                }
                                if (shoot) {
                                    $t2 = Bridge.getEnumerator(shooterAction_.shotData);
                                    while ($t2.moveNext()) {
                                        var shotData = $t2.getCurrent();
                                        AlienAttack.App.shots.add(Bridge.merge(new AlienAttack.Shot(), {
                                            shotType: shotData._ShotType,
                                            x: plant.x,
                                            y: ((plant.y + shotData.lineDif) | 0),
                                            range: shotData.range,
                                            source: plant,
                                            backwards: shotData.backwards
                                        } ));
                                    }
                                }
                            }, 1500));
                        } else if (Bridge.is(action, AlienAttack.SunMakeAction)) {
                            var sunMake = Bridge.cast(action, AlienAttack.SunMakeAction);
                            AlienAttack.App.intervals.get(plant).add(Bridge.global.setInterval(function () {
                                AlienAttack.App.sun.add(Bridge.merge(new AlienAttack.Sun(), {
                                    amount: plant.framesSincePlanting > sunMake.growTime ? 25 : sunMake.sunAmount,
                                    x: plant.x,
                                    y: plant.y
                                } ));
                            }, 24000));
                        }
                    }).call(this);
                }
            },
            doInstantDamage: function (instantDamage, plant) {
                var $t, $t1, $t2;
                var x = plant.x;
                var y = plant.y;
                var toRemove = new (System.Collections.Generic.List$1(AlienAttack.Zombie))();
                $t = Bridge.getEnumerator(AlienAttack.App.zombies);
                while ($t.moveNext()) {
                    var zombie = $t.getCurrent();
                    if (Bridge.Math.round(zombie.x, 0, 6) > ((x - instantDamage.areaRadiusC) | 0) && Bridge.Math.round(zombie.x, 0, 6) < ((x + instantDamage.areaRadiusC) | 0) && zombie.y > ((y - instantDamage.areaRadiusC) | 0) && zombie.y < ((y + instantDamage.areaRadiusC) | 0)) {
                        zombie.doDamageTo(instantDamage.damage);
                        if (zombie.health <= 0) {
                            toRemove.add(zombie);
                        }
                    }
                }
                $t1 = Bridge.getEnumerator(toRemove);
                while ($t1.moveNext()) {
                    var remove = $t1.getCurrent();
                    AlienAttack.App.zombies.remove(remove);
                }
                if (instantDamage.leavesCrater) {
                    $t2 = Bridge.getEnumerator(System.Linq.Enumerable.from(AlienAttack.App.plants).where(function (v) {
                            return v.x === x && v.y === y;
                        }));
                    while ($t2.moveNext()) {
                        var plant_ = $t2.getCurrent();
                        AlienAttack.App.plants.remove(plant_);
                    }
                    AlienAttack.App.plants.add(AlienAttack.Plant.createPlant(AlienAttack.App.crater, x, y));
                }
            },
            getAt: function (x, y) {
                if (x < 0 || y < 0 || x >= AlienAttack.App.gridWidth || y >= AlienAttack.App.gridHeight) {
                    return AlienAttack.GridTile.None;
                }
                return AlienAttack.GridTile.Day;
            },
            update: function () {
                var $t, $t1, $t2, $t3, $t4, $t5, $t6, $t7, $t8, $t9, $t10, $t11, $t12, $t13, $t14, $t15, $t16;
                document.getElementById("sunAmount").innerHTML = AlienAttack.App.sun$1.toString();
                var context = AlienAttack.App.getCanvas().getContext("2d");
                context.clearRect(0, 0, 900, 500);
                for (var x = 0; x < AlienAttack.App.gridWidth; x = (x + 1) | 0) {
                    for (var y = 0; y < AlienAttack.App.gridHeight; y = (y + 1) | 0) {
                        switch (AlienAttack.App.getAt(x, y)) {
                            case AlienAttack.GridTile.Day: 
                                if (AlienAttack.App.levelType === AlienAttack.LevelType.Night) {
                                    context.strokeStyle = "#000000";
                                    context.fillStyle = "#000080";
                                } else {
                                    context.strokeStyle = "#008000";
                                    context.fillStyle = "#80ff80";
                                }
                                break;
                            default: 
                                break;
                        }
                        context.lineWidth = 1;
                        context.strokeRect(((x * AlienAttack.App.squareWidth) | 0), ((y * AlienAttack.App.squareHeight) | 0), AlienAttack.App.squareWidth, AlienAttack.App.squareHeight);
                        context.fillRect(((((x * AlienAttack.App.squareWidth) | 0) + 1) | 0), ((((y * AlienAttack.App.squareHeight) | 0) + 1) | 0), 98, 98);
                    }
                }
                var index;
                if (((index = AlienAttack.App.frameMilestones.indexOf(AlienAttack.App.frames))) !== -1) {
                    if ((((index + 1) | 0)) % 50 === 0) {
                        AlienAttack.App.startZombiePlan();
                    }
                    AlienAttack.App.zombies.add(AlienAttack.Zombie.create(AlienAttack.App.zombieTypes.getItem(AlienAttack.App.rnd.next$1(Math.min(AlienAttack.App.zombieTypes.getCount(), ((Bridge.Int.div(index, 5)) | 0)))), AlienAttack.App.gridWidth, AlienAttack.App.rnd.next$1(AlienAttack.App.gridHeight)));
                }
                $t = Bridge.getEnumerator(AlienAttack.App.plantTypes);
                while ($t.moveNext()) {
                    var plant = $t.getCurrent();
                    if (((plant.sinceLastPlanting = (plant.sinceLastPlanting + 1) | 0)) === AlienAttack.App.rechargeTimes.get(plant.rechargeTime)) {
                        if (!plant.unPlantable) {
                            AlienAttack.App.plantTable.get(plant).style.color = Bridge.referenceEquals(plant, AlienAttack.App.selected) ? "orange" : "black";
                        }
                    }
                }
                var toRemovePlant = new (System.Collections.Generic.List$1(AlienAttack.Plant))();
                $t1 = Bridge.getEnumerator(AlienAttack.App.plants);
                while ($t1.moveNext()) {
                    (function () {
                        var plant1 = $t1.getCurrent();
                        var activated = null;
                        var metrics = context.measureText(plant1.type.name);
                        var gVal = 0;
                        if (plant1.type.anim != null) {
                            for (var n = (plant1.type.anim.length - 1) | 0; n >= 0; n = (n - 1) | 0) {
                                if (plant1.health < plant1.type.anim[n]) {
                                    gVal = (gVal + 1) | 0;
                                }
                            }
                            context.fillStyle = AlienAttack.App.animColors[gVal];
                        } else if (plant1.asleep) {
                            context.fillStyle = "#ffffff";
                        } else {
                            context.fillStyle = "#0040ff";
                        }
                        if (!plant1.asleep) {
                            plant1.framesSincePlanting = (plant1.framesSincePlanting + 1) | 0;
                            if (System.Linq.Enumerable.from(plant1.type.actions).any($asm.$.AlienAttack.App.f32)) {
                                activated = System.Linq.Enumerable.from(plant1.type.actions).any(function (v) {
                                        var $t2;
                                        return Bridge.is(v, AlienAttack.InstantDamageAction) && System.Nullable.lt((($t2 = Bridge.cast(v, AlienAttack.InstantDamageAction)) != null ? $t2.activationTime : null), plant1.framesSincePlanting);
                                    });
                            }
                            if (System.Linq.Enumerable.from(plant1.type.actions).any($asm.$.AlienAttack.App.f33)) {
                                $t2 = Bridge.getEnumerator(plant1.type.actions);
                                while ($t2.moveNext()) {
                                    (function () {
                                        var action = $t2.getCurrent();
                                        if (Bridge.is(action, AlienAttack.EatZombieAction) && !plant1.recharging) {
                                            var eatZomb = Bridge.cast(action, AlienAttack.EatZombieAction);
                                            var zombie;
                                            if (((zombie = System.Linq.Enumerable.from(AlienAttack.App.zombies).firstOrDefault(function (v) {
                                                    return (Math.abs(Bridge.Math.round(v.x, 0, 6) - plant1.x) < 2) && v.y === plant1.y;
                                                }, null))) != null) {
                                                plant1.recharging = true;
                                                Bridge.global.setTimeout(function () {
                                                    plant1.recharging = false;
                                                }, ((Bridge.Int.div((((eatZomb.rechargeTime * AlienAttack.App.fps) | 0)), 20)) | 0));
                                                zombie.health = 0;
                                            }
                                        }
                                    }).call(this);
                                }
                            }
                            if (System.Linq.Enumerable.from(plant1.type.actions).any($asm.$.AlienAttack.App.f34)) {
                                $t3 = Bridge.getEnumerator(System.Linq.Enumerable.from(AlienAttack.App.plants).where(function (v) {
                                        return v.x === plant1.x && v.y === plant1.y;
                                    }));
                                while ($t3.moveNext()) {
                                    var shoveler = $t3.getCurrent();
                                    AlienAttack.App.removePlantUpdateAnim(shoveler);
                                    toRemovePlant.add(shoveler);
                                }
                            }
                            if (System.Linq.Enumerable.from(plant1.type.actions).any($asm.$.AlienAttack.App.f35)) {
                                if (plant1.framesSincePlanting >= Bridge.cast(System.Linq.Enumerable.from(plant1.type.actions).first($asm.$.AlienAttack.App.f35), AlienAttack.WakeUpAction).activationTime) {
                                    $t4 = Bridge.getEnumerator(System.Linq.Enumerable.from(AlienAttack.App.plants).where(function (v) {
                                            return v.x === plant1.x && v.y === plant1.y && v.asleep;
                                        }));
                                    while ($t4.moveNext()) {
                                        var asleepPlant = $t4.getCurrent();
                                        toRemovePlant.add(asleepPlant);
                                        var plantW;
                                        AlienAttack.App.plants.add((plantW = AlienAttack.Plant.createPlant(asleepPlant.type, asleepPlant.x, asleepPlant.y)));
                                        AlienAttack.App.updateShotsAnim(plantW);
                                    }
                                    toRemovePlant.add(plant1);
                                }
                            }
                            if (System.Linq.Enumerable.from(plant1.type.actions).any($asm.$.AlienAttack.App.f36)) {
                                $t5 = Bridge.getEnumerator(plant1.type.actions);
                                while ($t5.moveNext()) {
                                    var action1 = $t5.getCurrent();
                                    if (Bridge.is(action1, AlienAttack.SpikeAction)) {
                                        var spikeAction = Bridge.cast(action1, AlienAttack.SpikeAction);
                                        if (plant1.framesSincePlanting % spikeAction.rate === 0) {
                                            AlienAttack.App.doInstantDamage(spikeAction.damage, plant1);
                                        }
                                    }
                                }
                            }
                            if (($t6 = activated, $t6 != null ? $t6 : false)) {
                                $t7 = Bridge.getEnumerator(plant1.type.actions);
                                while ($t7.moveNext()) {
                                    (function () {
                                        var action2 = $t7.getCurrent();
                                        if (Bridge.is(action2, AlienAttack.InstantDamageAction)) {
                                            var instantD = Bridge.cast(action2, AlienAttack.InstantDamageAction);
                                            if (System.Linq.Enumerable.from(AlienAttack.App.zombies).any(function (v) {
                                                    return Bridge.Math.round(v.x, 0, 6) === plant1.x && v.y === plant1.y;
                                                }) || !instantD.zombieActivated) {
                                                AlienAttack.App.doInstantDamage(instantD, plant1);
                                                toRemovePlant.add(plant1);
                                            }
                                        }
                                    }).call(this);
                                }
                            }
                        }
                        if (plant1.type.image) {
                            if (plant1.type.anim != null) {
                                context.drawImage(AlienAttack.App.images.get(System.String.format("{0} {1} {2}", plant1.type.name, Math.min(((((Bridge.Int.div(plant1.framesSincePlanting, 4)) | 0) + 1) | 0), plant1.type.nFrames), gVal)), ((AlienAttack.App.squareWidth * plant1.x) | 0), ((AlienAttack.App.squareHeight * plant1.y) | 0));
                            } else {
                                context.drawImage(AlienAttack.App.images.get(System.String.format("{0} {1}", plant1.type.name, Math.min(((((Bridge.Int.div(plant1.framesSincePlanting, 4)) | 0) + 1) | 0), plant1.type.nFrames))), ((AlienAttack.App.squareWidth * plant1.x) | 0), ((AlienAttack.App.squareHeight * plant1.y) | 0));
                            }
                        } else {
                            context.fillText(System.String.concat(plant1.type.name, ((activated == null) ? "" : ((($t8 = activated, $t8 != null ? $t8 : false)) ? "(Activated)" : "(Deactivated)"))), ((plant1.x * AlienAttack.App.squareWidth) | 0) + ((AlienAttack.App.squareWidth - metrics.width) / 2), ((((plant1.y * AlienAttack.App.squareHeight) | 0) + 10) | 0));
                        }
                    }).call(this);
                }
                $t9 = Bridge.getEnumerator(toRemovePlant);
                while ($t9.moveNext()) {
                    var plantRemove = $t9.getCurrent();
                    AlienAttack.App.plants.remove(plantRemove);
                }
                var toRemove = new (System.Collections.Generic.List$1(AlienAttack.Zombie))();
                $t10 = Bridge.getEnumerator(AlienAttack.App.zombies);
                while ($t10.moveNext()) {
                    $t11 = (function () {
                        var zombie1 = $t10.getCurrent();
                        var yesShot = null;
                        $t12 = Bridge.getEnumerator(AlienAttack.App.shots);
                        while ($t12.moveNext()) {
                            var shot = $t12.getCurrent();
                            if (Math.abs(shot.x - zombie1.x) <= (zombie1.zombieType.speed * 2) / 50.0 && shot.y === zombie1.y) {
                                yesShot = shot;
                                if (shot.shotType !== AlienAttack.ShotData.ShotType.GoThroughSpore) {
                                    AlienAttack.App.shots.remove((yesShot = shot));
                                }
                                break;
                            }
                        }
                        var plantFound = false;
                        $t13 = Bridge.getEnumerator(AlienAttack.App.plants);
                        while ($t13.moveNext()) {
                            var plant2 = $t13.getCurrent();
                            if ((plant2.type.unEatable && !zombie1.zombieType.smasher) || plant2.type.unSmashable) {
                                continue;
                            }
                            if (zombie1.zombieType.instantSmash) {
                                plant2.health = 0;
                                continue;
                            }
                            if (Math.abs(plant2.x - zombie1.x) <= (zombie1.zombieType.speed * 2) / 50.0 && plant2.y === zombie1.y) {
                                if (zombie1.zombieType.plantJumper && !zombie1.jumped) {
                                    if (!plant2.type.unJumpable) {
                                        zombie1.x -= 1 + (zombie1.zombieType.speed * 3) / 50.0;
                                    }
                                    zombie1.jumped = true;
                                } else {
                                    var biteDamage = zombie1.zombieType.smasher ? plant2.type.startingHealth / 200 : 0.05;
                                    if (System.Linq.Enumerable.from(plant2.type.actions).any($asm.$.AlienAttack.App.f37)) {
                                        if (((zombie1.biteA = zombie1.biteA + biteDamage)) >= 1) {
                                            zombie1.biteA = 0;
                                            var y1;
                                            var x1 = Bridge.Int.clip32(Bridge.Math.round(zombie1.x, 0, 6)); /// Possible mistaken empty statement


                                            do {
                                                ;
                                            } while (AlienAttack.App.getAt(x1, ((y1 = ((((((AlienAttack.App.rnd.next$1(2) * 2) | 0) - 1) | 0)) + Bridge.Int.clip32(Bridge.Math.round(zombie1.y, 0, 6))) | 0))) !== AlienAttack.App.getAt(x1, Bridge.Int.clip32(Bridge.Math.round(zombie1.y, 0, 6)))); /// Possible mistaken empty statement


                                            zombie1.y = y1;
                                        }
                                    }
                                    plant2.health -= biteDamage;
                                    if (zombie1.frozenFrames !== 0) {
                                        plant2.health += 0.025;
                                    }
                                    if (plant2.health <= 0) {
                                        AlienAttack.App.plants.remove(plant2);
                                        AlienAttack.App.removePlantUpdateAnim(plant2);
                                    }
                                    plantFound = true;
                                }
                                break;
                            }
                        }
                        var damage = 1;
                        if (yesShot == null) {
                            damage = 0;
                        }
                        switch (yesShot != null ? yesShot.shotType : null) {
                            case AlienAttack.ShotData.ShotType.Fire: 
                                damage = 4;
                                break;
                            case AlienAttack.ShotData.ShotType.Frozen: 
                                zombie1.frozenFrames = 200;
                                break;
                        }
                        if (System.Nullable.eq((yesShot != null ? yesShot.shotType : null), AlienAttack.ShotData.ShotType.GoThroughSpore)) {
                            zombie1.health -= damage;
                            zombie1.itemHealth = Math.max(zombie1.itemHealth - damage, 0);
                        } else {
                            zombie1.doDamageTo(damage);
                        }
                        if (zombie1.health <= 0) {
                            toRemove.add(zombie1);
                            return {jump:1};
                        }
                        if (zombie1.zombieType.throwZombie != null) {
                            if (zombie1.health <= zombie1.zombieType.startingHealth / 2 && !zombie1.thrownZombie && zombie1.x > 3) {
                                AlienAttack.App.zombies.add(AlienAttack.Zombie.create(zombie1.zombieType.throwZombie, zombie1.x - zombie1.zombieType.throwDistance, zombie1.y));
                                zombie1.thrownZombie = true;
                            }
                        } else if (zombie1.itemHealth <= 0) {
                            if (!zombie1.frozen && !zombie1.angry) {
                                Bridge.global.setTimeout(function () {
                                    zombie1.angry = true;
                                    zombie1.frozen = false;
                                }, ((Bridge.Int.div(((zombie1.zombieType.angerHeatTime * AlienAttack.App.fps) | 0), 20)) | 0));
                                zombie1.frozen = true;
                            }
                        }
                        var distanceInFrame = (zombie1.frozen ? 0 : (Math.pow(1.3, (zombie1.jumped ? 1 : zombie1.zombieType.speed) - 1) / AlienAttack.App.speedConstant) / (zombie1.frozenFrames === 0 ? 1 : 2));
                        if (!plantFound && ((zombie1.x = zombie1.x - distanceInFrame)) <= 0) {
                            Bridge.global.alert("You lose!");
                            Bridge.global.location.reload();
                        }
                        if (zombie1.lastSquareX - zombie1.x >= 1) {
                            if (zombie1.zombieType.leavesIceTrail) {
                                zombie1.lastSquareX = zombie1.x;
                                AlienAttack.App.plants.add(AlienAttack.Plant.createPlant(AlienAttack.App.plantTypes.getItem(((AlienAttack.App.plantTypes.getCount() - 2) | 0)), Bridge.Int.clip32(Bridge.Math.round(zombie1.x, 0, 6)), Bridge.Int.clip32(Bridge.Math.round(zombie1.y, 0, 6))));
                            }
                            if (zombie1.zombieType.danceBackupZombie != null) {

                            }
                        }
                        context.fillStyle = zombie1.frozenFrames === 0 ? "#ff0000" : "#ffffff";
                        var metrics1 = context.measureText(zombie1.zombieType.name);
                        context.fillText(zombie1.zombieType.name, (zombie1.x + 1) * AlienAttack.App.squareWidth, ((Bridge.Int.clip32(zombie1.y * AlienAttack.App.squareHeight) + 10) | 0));
                        context.fillRect((zombie1.x + 1) * AlienAttack.App.squareWidth, (((Bridge.Int.clip32(zombie1.y * AlienAttack.App.squareHeight) + 10) | 0)), (metrics1.width * zombie1.health) / zombie1.zombieType.startingHealth, 10);
                        if (zombie1.itemHealth !== 0) {
                            context.fillRect((zombie1.x + 1) * AlienAttack.App.squareWidth, (((Bridge.Int.clip32(zombie1.y * AlienAttack.App.squareHeight) + 20) | 0)), (metrics1.width * zombie1.itemHealth) / zombie1.zombieType.startingItemHealth, 10);
                        }
                    }).call(this) || {};
                    if($t11.jump == 1) continue;
                }
                $t11 = Bridge.getEnumerator(toRemove);
                while ($t11.moveNext()) {
                    var remover = $t11.getCurrent();
                    AlienAttack.App.zombies.remove(remover);
                }
                var toRemoveShot = new (System.Collections.Generic.List$1(AlienAttack.Shot))();
                $t14 = Bridge.getEnumerator(AlienAttack.App.shots);
                while ($t14.moveNext()) {
                    var shot1 = $t14.getCurrent();
                    var inc = 0.02;
                    if (shot1.backwards) {
                        inc = -inc;
                    }
                    shot1.distanceTravelled += inc;
                    shot1.x += inc;
                    context.fillStyle = AlienAttack.App.colors.get(shot1.shotType);
                    if (shot1.shotType === AlienAttack.ShotData.ShotType.Spore || shot1.shotType === AlienAttack.ShotData.ShotType.GoThroughSpore) {
                        context.strokeStyle = context.fillStyle;
                        context.lineWidth = 5;
                        context.beginPath();
                        context.moveTo((shot1.source.x + 0.5) * AlienAttack.App.squareWidth, (shot1.source.y + 0.5) * AlienAttack.App.squareHeight);
                        context.lineTo((shot1.x + 0.5) * AlienAttack.App.squareWidth, (shot1.y + 0.5) * AlienAttack.App.squareHeight);
                        context.stroke();
                    } else {
                        context.beginPath();
                        context.arc(shot1.x * AlienAttack.App.squareWidth, (shot1.y + 0.5) * AlienAttack.App.squareHeight, 15, 0, 2 * Math.PI);
                        context.fill();
                    }
                    if (shot1.distanceTravelled >= shot1.range) {
                        toRemoveShot.add(shot1);
                    }
                }
                $t15 = Bridge.getEnumerator(toRemoveShot);
                while ($t15.moveNext()) {
                    var removeShot = $t15.getCurrent();
                    AlienAttack.App.shots.remove(removeShot);
                }
                $t16 = Bridge.getEnumerator(AlienAttack.App.sun);
                while ($t16.moveNext()) {
                    var _sun = $t16.getCurrent();
                    context.fillStyle = "#ffff00";
                    context.beginPath();
                    context.arc((_sun.x + 0.5) * AlienAttack.App.squareWidth, (_sun.y + 0.5) * AlienAttack.App.squareHeight, _sun.amount, 0, 2 * Math.PI);
                    context.fill();
                }
                AlienAttack.App.frames = (AlienAttack.App.frames + 1) | 0;
            }
        },
        $main: function () {
            var $step = 0,
                $task1, 
                $jumpFromFinally, 
                select, 
                names, 
                n, 
                $t, 
                plant, 
                $t1, 
                plantType, 
                row, 
                cell, 
                span, 
                $asyncBody = Bridge.fn.bind(this, function () {
                    for (;;) {
                        $step = System.Array.min([0,1], $step);
                        switch ($step) {
                            case 0: {
                                $task1 = AlienAttack.App.loadImages();
                                    $step = 1;
                                    $task1.continueWith($asyncBody, true);
                                    return;
                            }
                            case 1: {
                                $task1.getAwaitedResult();
                                select = document.getElementById("levelType");
                                    select.oninput = function (e) {
                                        AlienAttack.App.levelType = System.Int32.parse(select.value);
                                    };
                                    names = System.Enum.getNames(AlienAttack.LevelType);
                                    for (n = 0; n < names.length; n = (n + 1) | 0) {
                                        select.appendChild(Bridge.merge(document.createElement('option'), {
                                            value: n.toString(),
                                            innerHTML: names[n]
                                        } ));
                                    }
                                    $t = Bridge.getEnumerator(AlienAttack.App.plantTypes);
                                    while ($t.moveNext()) {
                                        plant = $t.getCurrent();
                                        switch (plant.rechargeTime) {
                                            case AlienAttack.RechargeTime.VerySlow: 
                                                plant.sinceLastPlanting = 750;
                                                break;
                                            case AlienAttack.RechargeTime.Slow: 
                                                plant.sinceLastPlanting = 500;
                                                break;
                                            case AlienAttack.RechargeTime.Fast: 
                                                plant.sinceLastPlanting = 375;
                                                break;
                                        }
                                    }
                                    AlienAttack.App.selected = AlienAttack.App.plantTypes.getItem(0);
                                    //shotsAnim = new int[gridHeight];
                                    AlienAttack.App.getCanvas().onmousedown = AlienAttack.App.mouseDown;
                                    AlienAttack.App.startZombiePlan();
                                    Bridge.global.setInterval(AlienAttack.App.update, AlienAttack.App.fps);
                                    if (AlienAttack.App.levelType === AlienAttack.LevelType.Day) {
                                        Bridge.global.setInterval($asm.$.AlienAttack.App.f38, 10000);
                                    }
                                    $t1 = Bridge.getEnumerator(AlienAttack.App.plantTypes);
                                    while ($t1.moveNext()) {
                                        plantType = $t1.getCurrent();
                                        if (plantType.unPlantable) {
                                            continue;
                                        }
                                        row = document.createElement('tr');
                                        AlienAttack.App.getTable().appendChild(row);
                                        cell = document.createElement('td');
                                        span = Bridge.merge(document.createElement('span'), {
                                            innerHTML: plantType.name,
                                            onclick: AlienAttack.App.selectWorkaround
                                        } );
                                        span.style.color = plantType.sinceLastPlanting === 375 ? "black" : "#ffff80";
                                        AlienAttack.App.plantTable.add(plantType, span);
                                        AlienAttack.App.spans.add(plantType, span);
                                        cell.appendChild(span);
                                        row.appendChild(cell);
                                    }
                                    AlienAttack.App.select(AlienAttack.App.plantTypes.getItem(0));
                                return;
                            }
                            default: {
                                return;
                            }
                        }
                    }
                }, arguments);

            $asyncBody();
        }
    });

    Bridge.ns("AlienAttack.App", $asm.$);

    Bridge.apply($asm.$.AlienAttack.App, {
        f1: function (_o1) {
            _o1.add(Bridge.merge(new AlienAttack.ZombieType(), {
                name: "Zombie",
                startingHealth: 10
            } ));
            _o1.add(Bridge.merge(new AlienAttack.ZombieType(), {
                name: "Pole Vaulting Zombie",
                speed: 2,
                startingHealth: 17,
                plantJumper: true
            } ));
            _o1.add(Bridge.merge(new AlienAttack.ZombieType(), {
                name: "Conehead Zombie",
                startingHealth: 27.75
            } ));
            _o1.add(Bridge.merge(new AlienAttack.ZombieType(), {
                name: "Buckethead Zombie",
                magnetVulnerable: true,
                startingHealth: 65
            } ));
            _o1.add(Bridge.merge(new AlienAttack.ZombieType(), {
                name: "Newspaper Zombie",
                startingHealth: 9,
                startingItemHealth: 8,
                angerHeatTime: 1500
            } ));
            _o1.add(Bridge.merge(new AlienAttack.ZombieType(), {
                name: "Screen Door Zombie",
                magnetVulnerable: true,
                startingHealth: 10,
                startingItemHealth: 55
            } ));
            _o1.add(Bridge.merge(new AlienAttack.ZombieType(), {
                name: "Football Zombie",
                speed: 2,
                magnetVulnerable: true,
                startingHealth: 80
            } ));
            _o1.add(Bridge.merge(new AlienAttack.ZombieType(), {
                name: "Zomboni",
                startingHealth: 58,
                smasher: true,
                instantSmash: true,
                leavesIceTrail: true
            } ));
            _o1.add(Bridge.merge(new AlienAttack.ZombieType(), {
                name: "Dancing Zombie",
                startingHealth: 17,
                danceBackupZombie: AlienAttack.App.backupDancer
            } ));
            _o1.add(Bridge.merge(new AlienAttack.ZombieType(), {
                name: "Gargantuar",
                startingHealth: 150,
                throwZombie: AlienAttack.App.imp,
                throwDistance: 4,
                smasher: true
            } ));
            return _o1;
        },
        f2: function (_o2) {
            _o2.add(Bridge.merge(new AlienAttack.ShotData(), {
                range: 10,
                _ShotType: AlienAttack.ShotData.ShotType.Normal
            } ));
            return _o2;
        },
        f3: function (_o3) {
            _o3.add(Bridge.merge(new AlienAttack.ShooterAction(), {
                shotData: $asm.$.AlienAttack.App.f2(new (System.Collections.Generic.List$1(AlienAttack.ShotData))())
            } ));
            return _o3;
        },
        f4: function (_o4) {
            _o4.add(Bridge.merge(new AlienAttack.SunMakeAction(), {
                sunAmount: 25
            } ));
            return _o4;
        },
        f5: function (_o5) {
            _o5.add(Bridge.merge(new AlienAttack.InstantDamageAction(), {
                activationTime: 60,
                areaRadiusC: 2,
                damage: 90,
                zombieActivated: false
            } ));
            return _o5;
        },
        f6: function (_o6) {
            _o6.add(Bridge.merge(new AlienAttack.InstantDamageAction(), {
                activationTime: 750,
                areaRadiusC: 1,
                damage: 90,
                zombieActivated: true
            } ));
            return _o6;
        },
        f7: function (_o7) {
            _o7.add(Bridge.merge(new AlienAttack.ShotData(), {
                range: 10,
                _ShotType: AlienAttack.ShotData.ShotType.Frozen
            } ));
            return _o7;
        },
        f8: function (_o8) {
            _o8.add(Bridge.merge(new AlienAttack.ShooterAction(), {
                shotData: $asm.$.AlienAttack.App.f7(new (System.Collections.Generic.List$1(AlienAttack.ShotData))())
            } ));
            return _o8;
        },
        f9: function (_o9) {
            _o9.add(Bridge.merge(new AlienAttack.EatZombieAction(), {
                rechargeTime: 42000
            } ));
            return _o9;
        },
        f10: function (_o10) {
            _o10.add(Bridge.merge(new AlienAttack.ShotData(), {
                range: 10,
                _ShotType: AlienAttack.ShotData.ShotType.Normal
            } ));
            _o10.add(Bridge.merge(new AlienAttack.ShotData(), {
                range: 10,
                _ShotType: AlienAttack.ShotData.ShotType.Normal
            } ));
            return _o10;
        },
        f11: function (_o11) {
            _o11.add(Bridge.merge(new AlienAttack.ShooterAction(), {
                shotData: $asm.$.AlienAttack.App.f10(new (System.Collections.Generic.List$1(AlienAttack.ShotData))())
            } ));
            return _o11;
        },
        f12: function (_o12) {
            _o12.add(Bridge.merge(new AlienAttack.ShotData(), {
                range: 3,
                _ShotType: AlienAttack.ShotData.ShotType.Spore
            } ));
            return _o12;
        },
        f13: function (_o13) {
            _o13.add(Bridge.merge(new AlienAttack.ShooterAction(), {
                shotData: $asm.$.AlienAttack.App.f12(new (System.Collections.Generic.List$1(AlienAttack.ShotData))())
            } ));
            return _o13;
        },
        f14: function (_o14) {
            _o14.add(Bridge.merge(new AlienAttack.SunMakeAction(), {
                sunAmount: 15,
                growTime: 6000
            } ));
            return _o14;
        },
        f15: function (_o15) {
            _o15.add(Bridge.merge(new AlienAttack.ShotData(), {
                range: 5,
                _ShotType: AlienAttack.ShotData.ShotType.GoThroughSpore
            } ));
            return _o15;
        },
        f16: function (_o16) {
            _o16.add(Bridge.merge(new AlienAttack.ShooterAction(), {
                shotData: $asm.$.AlienAttack.App.f15(new (System.Collections.Generic.List$1(AlienAttack.ShotData))())
            } ));
            return _o16;
        },
        f17: function (_o17) {
            _o17.add(Bridge.merge(new AlienAttack.InstantDamageAction(), {
                activationTime: 0,
                areaRadiusC: 4,
                damage: 90,
                zombieActivated: false,
                leavesCrater: true
            } ));
            return _o17;
        },
        f18: function (_o18) {
            _o18.add(Bridge.merge(new AlienAttack.InstantDamageAction(), {
                activationTime: 0,
                areaRadiusC: 1,
                damage: 90,
                zombieActivated: true
            } ));
            return _o18;
        },
        f19: function (_o19) {
            _o19.add(Bridge.merge(new AlienAttack.ShotData(), {
                range: 10,
                _ShotType: AlienAttack.ShotData.ShotType.Normal
            } ));
            _o19.add(Bridge.merge(new AlienAttack.ShotData(), {
                range: 10,
                lineDif: -1,
                _ShotType: AlienAttack.ShotData.ShotType.Normal
            } ));
            _o19.add(Bridge.merge(new AlienAttack.ShotData(), {
                range: 10,
                lineDif: 1,
                _ShotType: AlienAttack.ShotData.ShotType.Normal
            } ));
            return _o19;
        },
        f20: function (_o20) {
            _o20.add(Bridge.merge(new AlienAttack.ShooterAction(), {
                shotData: $asm.$.AlienAttack.App.f19(new (System.Collections.Generic.List$1(AlienAttack.ShotData))())
            } ));
            return _o20;
        },
        f21: function (_o21) {
            _o21.add(Bridge.merge(new AlienAttack.SpikeAction(), {
                damage: Bridge.merge(new AlienAttack.InstantDamageAction(), {
                    damage: 1,
                    activationTime: 0,
                    areaRadiusC: 1,
                    zombieActivated: false
                } ),
                rate: 50
            } ));
            return _o21;
        },
        f22: function (_o22) {
            _o22.add(Bridge.merge(new AlienAttack.ShotData(), {
                range: 10,
                _ShotType: AlienAttack.ShotData.ShotType.Normal
            } ));
            _o22.add(Bridge.merge(new AlienAttack.ShotData(), {
                range: 10,
                _ShotType: AlienAttack.ShotData.ShotType.Normal,
                backwards: true
            } ));
            return _o22;
        },
        f23: function (_o23) {
            _o23.add(Bridge.merge(new AlienAttack.ShooterAction(), {
                shotData: $asm.$.AlienAttack.App.f22(new (System.Collections.Generic.List$1(AlienAttack.ShotData))())
            } ));
            return _o23;
        },
        f24: function (_o24) {
            _o24.add(Bridge.merge(new AlienAttack.WakeUpAction(), {
                activationTime: 50
            } ));
            return _o24;
        },
        f25: function (_o25) {
            _o25.add(new AlienAttack.ChangeLineAction());
            return _o25;
        },
        f26: function (_o26) {
            _o26.add(new AlienAttack.ShovelAction());
            return _o26;
        },
        f27: function (_o27) {
            _o27.add(Bridge.merge(new AlienAttack.InstantDamageAction(), {
                activationTime: 1500,
                areaRadiusC: 1,
                damage: 0
            } ));
            return _o27;
        },
        f28: function (_o28) {
            _o28.add(Bridge.merge(new AlienAttack.InstantDamageAction(), {
                activationTime: 9000,
                areaRadiusC: 0,
                damage: 0,
                leavesCrater: false,
                zombieActivated: false
            } ));
            return _o28;
        },
        f29: function (_o29) {
            _o29.add(Bridge.merge(new AlienAttack.PlantType(), {
                name: "Peashooter",
                actions: $asm.$.AlienAttack.App.f3(new (System.Collections.Generic.List$1(AlienAttack.PlantAction))()),
                cost: 100,
                rechargeTime: AlienAttack.RechargeTime.Fast
            } ));
            _o29.add(Bridge.merge(new AlienAttack.PlantType(), {
                name: "Sunflower",
                actions: $asm.$.AlienAttack.App.f4(new (System.Collections.Generic.List$1(AlienAttack.PlantAction))()),
                cost: 50,
                rechargeTime: AlienAttack.RechargeTime.Fast
            } ));
            _o29.add(Bridge.merge(new AlienAttack.PlantType(), {
                name: "Cherry Bomb",
                cost: 150,
                actions: $asm.$.AlienAttack.App.f5(new (System.Collections.Generic.List$1(AlienAttack.PlantAction))()),
                rechargeTime: AlienAttack.RechargeTime.VerySlow
            } ));
            _o29.add(Bridge.merge(new AlienAttack.PlantType(), {
                name: "Wall-nut",
                startingHealth: 72.0,
                cost: 50,
                actions: new (System.Collections.Generic.List$1(AlienAttack.PlantAction))(),
                rechargeTime: AlienAttack.RechargeTime.Slow,
                anim: System.Array.init([24, 48], System.Int32),
                image: true
            } ));
            _o29.add(Bridge.merge(new AlienAttack.PlantType(), {
                name: "Potato Mine",
                cost: 25,
                actions: $asm.$.AlienAttack.App.f6(new (System.Collections.Generic.List$1(AlienAttack.PlantAction))()),
                rechargeTime: AlienAttack.RechargeTime.Slow
            } ));
            _o29.add(Bridge.merge(new AlienAttack.PlantType(), {
                name: "Snow Pea",
                actions: $asm.$.AlienAttack.App.f8(new (System.Collections.Generic.List$1(AlienAttack.PlantAction))()),
                cost: 175,
                rechargeTime: AlienAttack.RechargeTime.Fast
            } ));
            _o29.add(Bridge.merge(new AlienAttack.PlantType(), {
                name: "Chomper",
                actions: $asm.$.AlienAttack.App.f9(new (System.Collections.Generic.List$1(AlienAttack.PlantAction))()),
                cost: 150,
                rechargeTime: AlienAttack.RechargeTime.Fast
            } ));
            _o29.add(Bridge.merge(new AlienAttack.PlantType(), {
                name: "Repeater",
                actions: $asm.$.AlienAttack.App.f11(new (System.Collections.Generic.List$1(AlienAttack.PlantAction))()),
                cost: 200,
                rechargeTime: AlienAttack.RechargeTime.Fast
            } ));
            _o29.add(Bridge.merge(new AlienAttack.PlantType(), {
                name: "Puff-shroom",
                actions: $asm.$.AlienAttack.App.f13(new (System.Collections.Generic.List$1(AlienAttack.PlantAction))()),
                cost: 0,
                rechargeTime: AlienAttack.RechargeTime.Fast,
                nocturnal: true
            } ));
            _o29.add(Bridge.merge(new AlienAttack.PlantType(), {
                name: "Sun-shroom",
                nocturnal: true,
                cost: 25,
                rechargeTime: AlienAttack.RechargeTime.Fast,
                actions: $asm.$.AlienAttack.App.f14(new (System.Collections.Generic.List$1(AlienAttack.PlantAction))())
            } ));
            _o29.add(Bridge.merge(new AlienAttack.PlantType(), {
                name: "Fume-shroom",
                cost: 75,
                nocturnal: true,
                rechargeTime: AlienAttack.RechargeTime.Fast,
                actions: $asm.$.AlienAttack.App.f16(new (System.Collections.Generic.List$1(AlienAttack.PlantAction))())
            } ));
            _o29.add(Bridge.merge(new AlienAttack.PlantType(), {
                name: "Doom Shroom",
                actions: $asm.$.AlienAttack.App.f17(new (System.Collections.Generic.List$1(AlienAttack.PlantAction))()),
                cost: 125,
                rechargeTime: AlienAttack.RechargeTime.VerySlow,
                nocturnal: true
            } ));
            _o29.add(Bridge.merge(new AlienAttack.PlantType(), {
                name: "Squash",
                actions: $asm.$.AlienAttack.App.f18(new (System.Collections.Generic.List$1(AlienAttack.PlantAction))()),
                cost: 50,
                rechargeTime: AlienAttack.RechargeTime.Slow
            } ));
            _o29.add(Bridge.merge(new AlienAttack.PlantType(), {
                name: "Threepeater",
                actions: $asm.$.AlienAttack.App.f20(new (System.Collections.Generic.List$1(AlienAttack.PlantAction))()),
                cost: 325,
                rechargeTime: AlienAttack.RechargeTime.Fast
            } ));
            _o29.add(Bridge.merge(new AlienAttack.PlantType(), {
                name: "Spikeweed",
                rechargeTime: AlienAttack.RechargeTime.Fast,
                cost: 100,
                unEatable: true,
                actions: $asm.$.AlienAttack.App.f21(new (System.Collections.Generic.List$1(AlienAttack.PlantAction))())
            } ));
            _o29.add(Bridge.merge(new AlienAttack.PlantType(), {
                name: "Tall-nut",
                startingHealth: 144.0,
                cost: 125,
                actions: new (System.Collections.Generic.List$1(AlienAttack.PlantAction))(),
                rechargeTime: AlienAttack.RechargeTime.Slow,
                unJumpable: true,
                anim: System.Array.init([48, 96], System.Int32),
                image: true
            } ));
            _o29.add(Bridge.merge(new AlienAttack.PlantType(), {
                name: "Split Pea",
                actions: $asm.$.AlienAttack.App.f23(new (System.Collections.Generic.List$1(AlienAttack.PlantAction))()),
                cost: 125,
                rechargeTime: AlienAttack.RechargeTime.Fast
            } ));
            _o29.add(Bridge.merge(new AlienAttack.PlantType(), {
                name: "Coffee Bean",
                cost: 75,
                rechargeTime: AlienAttack.RechargeTime.Fast,
                actions: $asm.$.AlienAttack.App.f24(new (System.Collections.Generic.List$1(AlienAttack.PlantAction))()),
                overPlantable: true,
                image: true,
                nFrames: 12
            } ));
            _o29.add(Bridge.merge(new AlienAttack.PlantType(), {
                name: "Garlic",
                cost: 50,
                rechargeTime: AlienAttack.RechargeTime.Fast,
                actions: $asm.$.AlienAttack.App.f25(new (System.Collections.Generic.List$1(AlienAttack.PlantAction))()),
                startingHealth: 21,
                anim: System.Array.init([7, 14], System.Int32),
                image: true
            } ));
            _o29.add(Bridge.merge(new AlienAttack.PlantType(), {
                name: "Shovel",
                actions: $asm.$.AlienAttack.App.f26(new (System.Collections.Generic.List$1(AlienAttack.PlantAction))()),
                cost: 0,
                startingHealth: 1.0,
                rechargeTime: AlienAttack.RechargeTime.None,
                overPlantable: true
            } ));
            _o29.add(Bridge.merge(new AlienAttack.PlantType(), {
                name: "Ice",
                unPlantable: true,
                unEatable: true,
                unSmashable: true,
                actions: $asm.$.AlienAttack.App.f27(new (System.Collections.Generic.List$1(AlienAttack.PlantAction))())
            } ));
            _o29.add(Bridge.merge(new AlienAttack.PlantType(), {
                name: "Crater",
                actions: $asm.$.AlienAttack.App.f28(new (System.Collections.Generic.List$1(AlienAttack.PlantAction))()),
                cost: -1,
                startingHealth: 1.0,
                unPlantable: true,
                unEatable: true,
                unSmashable: true
            } ));
            return _o29;
        },
        f30: function (_o30) {
            _o30.add(AlienAttack.RechargeTime.None, 0);
            _o30.add(AlienAttack.RechargeTime.Fast, 375);
            _o30.add(AlienAttack.RechargeTime.Slow, 1500);
            _o30.add(AlienAttack.RechargeTime.VerySlow, 2500);
            return _o30;
        },
        f31: function (_o31) {
            _o31.add(AlienAttack.ShotData.ShotType.GoThroughSpore, "#ff0000");
            _o31.add(AlienAttack.ShotData.ShotType.Spore, "#905fad");
            _o31.add(AlienAttack.ShotData.ShotType.Frozen, "#5050ff");
            _o31.add(AlienAttack.ShotData.ShotType.Normal, "#ccffcc");
            _o31.add(AlienAttack.ShotData.ShotType.Fire, "#ff5050");
            return _o31;
        },
        f32: function (v) {
            return Bridge.is(v, AlienAttack.InstantDamageAction);
        },
        f33: function (v) {
            return Bridge.is(v, AlienAttack.EatZombieAction);
        },
        f34: function (v) {
            return Bridge.is(v, AlienAttack.ShovelAction);
        },
        f35: function (v) {
            return Bridge.is(v, AlienAttack.WakeUpAction);
        },
        f36: function (v) {
            return Bridge.is(v, AlienAttack.SpikeAction);
        },
        f37: function (v) {
            return Bridge.is(v, AlienAttack.ChangeLineAction);
        },
        f38: function () {
            AlienAttack.App.sun.add(Bridge.merge(new AlienAttack.Sun(), {
                x: AlienAttack.App.rnd.next$1(AlienAttack.App.gridWidth),
                y: AlienAttack.App.rnd.next$1(AlienAttack.App.gridHeight),
                amount: 25
            } ));
        }
    });

    Bridge.define("AlienAttack.PlantAction");

    Bridge.define("AlienAttack.GridTile", {
        $kind: "enum",
        statics: {
            Day: 0,
            None: 1
        }
    });

    Bridge.define("AlienAttack.LevelType", {
        $kind: "enum",
        statics: {
            Day: 0,
            Night: 1
        }
    });

    Bridge.define("AlienAttack.Plant", {
        statics: {
            createPlant: function (plantType, x, y) {
                return Bridge.merge(new AlienAttack.Plant(), {
                    health: plantType.startingHealth,
                    type: plantType,
                    x: x,
                    y: y
                } );
            }
        },
        type: null,
        asleep: false,
        health: 0,
        x: 0,
        y: 0,
        framesSincePlanting: 0,
        recharging: false
    });

    Bridge.define("AlienAttack.PlantType", {
        actions: null,
        startingHealth: 10,
        name: null,
        cost: 0,
        unPlantable: false,
        rechargeTime: 0,
        sinceLastPlanting: 0,
        unEatable: false,
        unJumpable: false,
        anim: null,
        nocturnal: false,
        overPlantable: false,
        unSmashable: false,
        image: false,
        nFrames: 1
    });

    Bridge.define("AlienAttack.RechargeTime", {
        $kind: "enum",
        statics: {
            VerySlow: 0,
            Slow: 1,
            Fast: 2,
            None: 3
        }
    });

    Bridge.define("AlienAttack.Shot", {
        shotType: 0,
        x: 0,
        y: 0,
        distanceTravelled: 0,
        range: 0,
        source: null,
        backwards: false
    });

    Bridge.define("AlienAttack.ShotData", {
        _ShotType: 0,
        range: 0,
        lineDif: 0,
        backwards: false
    });

    Bridge.define("AlienAttack.ShotData.ShotType", {
        $kind: "enum",
        statics: {
            Spore: 0,
            Frozen: 1,
            Normal: 2,
            Fire: 3,
            GoThroughSpore: 4
        }
    });

    Bridge.define("AlienAttack.Sun", {
        amount: 0,
        x: 0,
        y: 0
    });

    Bridge.define("AlienAttack.Zombie", {
        statics: {
            create: function (Type, x, y) {
                return Bridge.merge(new AlienAttack.Zombie(), {
                    x: x,
                    y: y,
                    health: Type.startingHealth,
                    zombieType: Type,
                    itemHealth: Type.startingItemHealth
                } );
            }
        },
        zombieType: null,
        jumped: false,
        frozenFrames: 0,
        health: 0,
        x: 0,
        y: 0,
        thrownZombie: false,
        itemHealth: 0,
        angry: false,
        frozen: false,
        lastSquareX: 9,
        biteA: 0,
        created: null,
        config: {
            init: function () {
                this.created = new (System.Collections.Generic.List$1(AlienAttack.Zombie))();
            }
        },
        doDamageTo: function (damage) {
            var damageToDoToItem = this.itemHealth > damage ? damage : this.itemHealth;
            this.itemHealth -= damageToDoToItem;
            this.health -= damage - damageToDoToItem;
        }
    });

    Bridge.define("AlienAttack.ZombieType", {
        startingHealth: 0,
        speed: 1,
        magnetVulnerable: false,
        plantJumper: false,
        name: null,
        throwZombie: null,
        throwDistance: 0,
        smasher: false,
        startingItemHealth: 0,
        angerHeatTime: -1,
        leavesIceTrail: false,
        instantSmash: false,
        danceBackupZombie: null
    });

    Bridge.define("AlienAttack.ChangeLineAction", {
        inherits: [AlienAttack.PlantAction]
    });

    Bridge.define("AlienAttack.EatZombieAction", {
        inherits: [AlienAttack.PlantAction],
        rechargeTime: 0
    });

    Bridge.define("AlienAttack.InstantDamageAction", {
        inherits: [AlienAttack.PlantAction],
        damage: 0,
        /**
         * This is the total area covered added 1 too and divided by 2.
         Eg. 1 to 1
         Eg. 3 to 2
         Eg. 5 to 3
         Eg. 7 to 4
         *
         * @instance
         */
        areaRadiusC: 0,
        zombieActivated: false,
        /**
         * Activation time in frames
         *
         * @instance
         */
        activationTime: 0,
        leavesCrater: false
    });

    Bridge.define("AlienAttack.ShooterAction", {
        inherits: [AlienAttack.PlantAction],
        shotData: null
    });

    Bridge.define("AlienAttack.ShovelAction", {
        inherits: [AlienAttack.PlantAction]
    });

    Bridge.define("AlienAttack.SpikeAction", {
        inherits: [AlienAttack.PlantAction],
        damage: null,
        /**
         * Rate of damage in frames.
         *
         * @instance
         */
        rate: 0
    });

    Bridge.define("AlienAttack.SunMakeAction", {
        inherits: [AlienAttack.PlantAction],
        sunAmount: 0,
        growTime: 2147483647
    });

    Bridge.define("AlienAttack.WakeUpAction", {
        inherits: [AlienAttack.PlantAction],
        activationTime: 0
    });
});
